packetQueue = {
	container: [],
	maxLength: 50,
	push: function(a) {
		if (this.container.unshift(a) >= this.maxLength) {
			return this.pop();
		}
	},
	pop: function() {
		return this.container.pop();
	}
}

function getSockets(win) {
	if (win == null) win = window;
	function injectHandlers(s) {
		s.__proto__.emit = function (a){
			var s = this, prevP, packet;
			(function(a) {
				var i;
				do {
					prevP = packet;
					packet = {
						ts: Date.now(),
						target: "out",
						name: a[0],
						args: [],
						parent: prevP,
						blocked: prevP != null,
					};
					for (i=1;i<a.length;i++) packet.args.push(a[i]);
					packetQueue.push(packet);
					var noEcho = this.silentEcho || this.sendEchoIgnore && this.sendEchoIgnore[packet.name];
					if (!noEcho) {
						//console.groupCollapsed(packet.ts+" Packet Intercepted! ("+packet.name+")");
						if (packet.args.length) {
							//console.group("Arguments ("+(a.length-1)+")");
							for (i=0;i<packet.args.length;i++) //console.log(packet.args[i]);
							console.groupEnd();
						}
						console.groupEnd();
					}
					if (this.sendHooks) {
						var hooks = this.sendHooks[name];
						if (hooks) {
							for (var key in hooks) {
								try {
									if (hooks[key] && hooks[key](s, a)) break;
								} catch(e) {console.error(e.stack);}
							}
						}
					}
				} while(packet.name != a[0]);
				var b = a.length-1 != packet.args.length; 
				if (!b) for (var i=1;!b&&i<a.length;i++) b = a[i] != packet.args[i-1];
				if (b) {
					prevP = packet;
					packet = {
						ts: Date.now(),
						target: "out",
						name: a[0],
						args: [],
						parent: prevP,
						blocked: prevP != null,
					};
					for (i=1;i<a.length;i++) packet.args.push(a[i]);
					packetQueue.push(packet);
					var noEcho = this.silentEcho || this.sendEchoIgnore && this.sendEchoIgnore[packet.name];
					if (!noEcho) {
						//console.groupCollapsed(packet.ts+" Packet Intercepted! ("+packet.name+")");
						if (packet.args.length) {
							//console.group("Arguments ("+(a.length-1)+")");
							for (i=0;i<packet.args.length;i++) //console.log(packet.args[i]);
							console.groupEnd();
						}
						console.groupEnd();
					}
				}
			})(arguments);
			var b=Array.prototype.slice.call(arguments,1),c=b[b.length-1],d={type:"event",name:a};return"function"==typeof c&&(d.id=++this.ackPackets,d.ack="data",this.acks[d.id]=c,b=b.slice(0,b.length-1)),d.args=b,this.packet(d);
		};
		s.__proto__.onPacket = function (a){
			if (!this.received) this.received = [];
			this.received.push(a);
			do {
				var name = a.name;
				var noEcho = this.silentEcho || this.receiveEchoIgnore && this.receiveEchoIgnore[name];
				if (!noEcho) {
					//console.groupCollapsed(Date.now()+" Packet Received! ("+a.name+")");
					if(a.args){
						//console.group("Arguments");
						for(var i=0;i<a.args.length;i++) //console.log(a.args[i]);
						console.groupEnd();
					}
					console.groupEnd();
				}
				if (this.receiveHooks) {
					var hooks = this.receiveHooks[name];
					if (hooks) {
						for (var key in hooks) {
							try {
								if (hooks[key] && hooks[key](this, a)) break;
							} catch(e) {
								console.error(e);
							}
						}
					}
				}
			} while (a.name != name);
			function d(){c.packet({type:"ack",args:b.util.toArray(arguments),ackId:a.id})}var c=this;switch(a.type){case"connect":this.$emit("connect");break;case"disconnect":this.name===""?this.socket.onDisconnect(a.reason||"booted"):this.$emit("disconnect",a.reason);break;case"message":case"json":var e=["message",a.data];a.ack=="data"?e.push(d):a.ack&&this.packet({type:"ack",ackId:a.id}),this.$emit.apply(this,e);break;case"event":var e=[a.name].concat(a.args);a.ack=="data"&&e.push(d),this.$emit.apply(this,e);break;case"ack":this.acks[a.ackId]&&(this.acks[a.ackId].apply(this,a.args),delete this.acks[a.ackId]);break;case"error":a.advice?this.socket.onError(a):a.reason=="unauthorized"?this.$emit("connect_failed",a.reason):this.$emit("error",a.reason)}
		};
		s.__proto__.addSendHandler = function(name, alias, fn) {
			if (!this.sendHooks) this.sendHooks = {};
			if (!this.sendHooks[name]) this.sendHooks[name] = {};
			this.sendHooks[name][alias] = fn;
		}
		s.__proto__.addReceiveHandler = function(name, alias, fn) {
			if (!this.receiveHooks) this.receiveHooks = {};
			if (!this.receiveHooks.hasOwnProperty(name)) this.receiveHooks[name] = {};
			this.receiveHooks[name][alias] = fn;
		}
		s.__proto__.dontEchoSend = function(name) {
			if (!this.sendEchoIgnore) this.sendEchoIgnore = {};
			this.sendEchoIgnore[name] = true;
		}
		s.__proto__.dontEchoReceive = function(name) {
			if (!this.receiveEchoIgnore) this.receiveEchoIgnore = {};
			this.receiveEchoIgnore[name] = true;
		}
		
		s.__proto__.$injected = true;
	}

	var sockets = [];
	for (var a in win) {
		var b = win[a];
		if (b && typeof(b) == "object" && b.socket && b.$events) {
			if (!b.sent) b.sent = [];
			if (!b.receive) b.receive = [];
			if (!b.$injected) injectHandlers(b);
			sockets.push(b);
		}
	}
	return sockets;
}

$(function() {
	var s_xscript = new CrossScriptConnection("socket-scan");
	sockets = getSockets(window);
	if (sockets.length > 0) {
		s_xscript.send("socket-injector", "socket-scan", (function(){
			var a = [];
			for (var i=0;i<sockets.length;i++) a.push(sockets[i].socket.options.resource);
			return a;
		})());
	}
});
