var Message = {
	create: function($a) {
		return Object.create(this).init($a);
	},
	init: function($a) {
		var msg = this;
		var a = $a.find('.msgtopic');
		if (a.children('a.forumlink.unread').length < 1) {
			this.read = true;
		}
		this.subject = a.children('a.forumlink').text();
		this.id = a.children('a.forumlink[href]').attr('href').match(/\/msgs\/(\d+)/)[1];
		var b = a.children('strong').children('a');
		this.sender = b.text().trim();
		if (b.attr('href')) this.senderId = b.attr('href').match(/\/clan-profile\/(\d+)/)[1];
		this.attachments = [];
		a = $a.find('.status-data').children('img[title]');
		a.each(function(i, a) {
			var b = $(a).attr('title').match(/contains ([^.]+)\./);
			if (b) msg.attachments.push(b[1]);
		});
		return this;
	},
	takeItems: function(callback) {
		// $.ajax({
		// 	type: "POST",
		// 	data: {id: this.id, page: "1"},
		// 	url: "includes/ol/mess_cen_take.php",
		// 	cache: false,
		// }).done(callback);
		$.ajax({
			type: "POST",
			data: {msg: this.id},
			url: "/msgs/take-items"
		}).done(callback);
	},
};

function getMessages() {
	var $messages = $('#ajaxbody').find('tbody').find('a.forumlink').parent().parent();
	var messages = {};
	for (var i=0;i<$messages.length;i++) {
		var message = Message.create($($messages[i]));
		messages[message.id] = message;
	}
	return messages;
}

function changeInboxPage(page, callback) {
	var a = Number($('#page').text())-1;
	if (page == null) page = a;
	$.ajax({
		type: "POST",
		url: "/msgs/page",
		data: {
			page: page,
			sent: false,
		},
	}).done(function(html) {
		$('#ajaxbody').html(html);
		if (a != page) {
			$('#page').text(page+1);
		}
	});
}

$(function() {
	var a = $('.inner-content');
	var b = $("<button>Take All Items</button>").click(function(evt) {
		b.attr('disabled', true).text("One moment...");
		var messages = getMessages();
		var keys = Object.getOwnPropertyNames(messages);
		var i = 0;
		var d = false;
		function takeNextItem() {
			while (i < keys.length) {
				var message = messages[keys[i++]];
				if (message.attachments.length) {
					d = true;
					message.takeItems(function() {
						setTimeout(function() {
							takeNextItem();
						}, 1000);
						b.text("Taking items: "+i+"/"+(keys.length));
					});
					return;
				}
			}
			if (d) {
				// changeInboxPage(null);
				location.reload();
			}
			b.text("Take All Items").attr('disabled', null);
		}
		takeNextItem();
		evt.preventDefault();
		return false;
	}).appendTo(a);
});