bond = function(id, callback) {
	$.ajax({
		type: "POST",
		data: {id: id},
		url: "includes/ol/fam_bonding.php",
		cache: false,
	}).done(function(html) {
		if (callback) callback(html);
	});
};

equip = function(fId, dId, act, callback) {
	$.ajax({
		data: {id: dId, itm: fId, act: act},
		url: "includes/familiar_inv.php"
	}).done(function(html){
		var a = /data: \{id: (\d+), itm: (\d+), act: (\d+)\},/;
		var b = html.match(a);
		if (b) {
			$(function(){ 
				$.ajax({
					data: {id: b[1], itm: b[2], act: b[3]},
					url: "includes/familiar_active.php"
				}).done(function(msg){
					if (callback) callback();
				});
			});
		}
	});
};

bondAll = function() {
	var a = $('a.clue[onclick]');
	var i = 0;
	var b = /equip\('(\d+)', '(\d+)', '(\d+)'\)/;
	var z = [];
	var c = function() {
		if (i >= a.length) {
			console.debug("Complete!");
			if (z.length) console.debug(z);
			return;
		}
		var img = $(a[i]).find("img").attr('src');
		var d = $(a[i++]).attr('onclick').match(b);
		if (d) {
			Item.create(d[1], "familiar", img, function(familiar) {
				equip(d[1], d[2], d[3], function() {
					setTimeout(function() {
						bond(d[1], function(html) {
							
							if (html.indexOf("You've earned") > -1) {
								console.debug("Bonded with "+d[1]+" ("+familiar.name+")");
							} else if (html.indexOf("already bonded with") > -1) {
								console.debug("Already bonded with "+d[1]+" ("+familiar.name+")");
							} else {
								console.error("Couldn't bond with "+d[1]+" ("+familiar.name+")");
								z.push(d[1]);
							}
							setTimeout(c, 1000);
						});
					}, 1000);
				});
			});
		}
	}
	c();
};

$(function() {
	var mainDiv = $("#super-container");
	var extendedGUI = $(document.createElement('div')).attr('class', 'extended').appendTo(mainDiv);

	var familiarUnequipRegex = /unequip\('([^']+)', '([^']+)', '([^']+)'\)/;

	var bondDiv = $(document.createElement('div')).attr('class', 'bond').appendTo(extendedGUI);
	var bondButton = $(document.createElement('input')).attr('class', 'redbutton anybutton').attr('type', 'button').attr('value', 'Bond').appendTo(bondDiv).click(function(evt){
		var a = $('#familiar');
		if (a.find('img').length > 0) {
			var b = a.find('input[value="Remove Familiar"]');
			if (b.length <= 0) b = a.find('input[value="Remove"]');
			var c = b.attr('onclick').match(familiarUnequipRegex);
			if (c) {
				var familiarId = Number(c[1]);

				var bondDiv = $('<div></div>').html('<img src="/images/layout/loading.gif"> loading...');
				bondDiv.appendTo('body');
				debug1 = bondDiv;
				bondDiv.dialog({
					autoOpen: false,
					title: "Bond with Familiar",
					width: 450,
					height: "auto",
					modal: true,
					resizable: false,
					draggable: false,
					closeOnEscape: true,
					open: function(evt, ui) {}
				}).dialog('open');

				bond(familiarId, function(stuff) {
					bondDiv.html(stuff);
				});
			} else {
				alert("No familiar detected!");
			}
		}
		evt.preventDefault();
		return false;
	});
});
