var Cards = [];

function getBase64Image(img) {
	// Create an empty canvas element
	var canvas = document.createElement("canvas");
	canvas.width = img.width;
	canvas.height = img.height;

	// Copy the image contents to the canvas
	var ctx = canvas.getContext("2d");
	ctx.drawImage(img, 0, 0);

	// Get the data-URL formatted image
	// Firefox supports PNG and JPEG. You could check img.src to
	// guess the original format, but be aware the using "image/jpg"
	// will re-encode the image.
	var dataURL = canvas.toDataURL("image/png");

	return dataURL.replace(/^data:image\/(png|jpg);base64,/, "");
}

function go(a) {
	setTimeout(function() {
		location = a;
	}, 1000+Math.random(1500));
}

$(function() {
	console.debug("HL");
	var a = $("#super-container").find("img[style='position:absolute; left:0px; top:0px; z-index:1;']");
	if (a[1] && a[1].src == "http://flightrising.com/images/hilo_cards/right-face-down.png") {
		console.debug("Detected game, checking card...");
		var b = getBase64Image(a[0]);
		for (var i=0;i<Cards.length;i++) {
			if (b == Cards[i]) {
				console.debug("Card found! ("+i+")");
				if (i < 7) {
					go("main.php?p=hilo&choice=hi");
				} else {
					go("main.php?p=hilo&choice=lo");
				}
				return;
			}
		}
		console.debug(b);
		alert("I don't know this card...");
		return;
	}
	if ($("input[type='button'][onclick='replayHilo()'].mb_button").length > 0) {
		console.debug("Playing again");
		go("main.php?p=hilo");
	}
});
